Commit 52e31c07 by Felix Abecassis

lxc-oci: support skopeo layer caching

This requires skopeo version 0.1.25 Signed-off-by: 's avatarFelix Abecassis <fabecassis@nvidia.com>
parent 0fd2b679
...@@ -34,6 +34,7 @@ for bin in skopeo umoci jq; do ...@@ -34,6 +34,7 @@ for bin in skopeo umoci jq; do
fi fi
done done
LOCALSTATEDIR="@LOCALSTATEDIR@"
LXC_TEMPLATE_CONFIG="@LXCTEMPLATECONFIG@" LXC_TEMPLATE_CONFIG="@LXCTEMPLATECONFIG@"
# Some useful functions # Some useful functions
...@@ -145,7 +146,7 @@ EOF ...@@ -145,7 +146,7 @@ EOF
return 0 return 0
} }
options=$(getopt -o u:h -l help,url:,username:,password:,\ options=$(getopt -o u:h -l help,url:,username:,password:,no-cache,\
name:,path:,rootfs:,mapped-uid:,mapped-gid: -- "$@") name:,path:,rootfs:,mapped-uid:,mapped-gid: -- "$@")
if [ $? -ne 0 ]; then if [ $? -ne 0 ]; then
...@@ -157,6 +158,7 @@ eval set -- "$options" ...@@ -157,6 +158,7 @@ eval set -- "$options"
OCI_URL="" OCI_URL=""
OCI_USERNAME= OCI_USERNAME=
OCI_PASSWORD= OCI_PASSWORD=
OCI_USE_CACHE="true"
LXC_MAPPED_GID= LXC_MAPPED_GID=
LXC_MAPPED_UID= LXC_MAPPED_UID=
...@@ -170,6 +172,7 @@ while :; do ...@@ -170,6 +172,7 @@ while :; do
-u|--url) OCI_URL=$2; shift 2;; -u|--url) OCI_URL=$2; shift 2;;
--username) OCI_USERNAME=$2; shift 2;; --username) OCI_USERNAME=$2; shift 2;;
--password) OCI_PASSWORD=$2; shift 2;; --password) OCI_PASSWORD=$2; shift 2;;
--no-cache) OCI_USE_CACHE="false"; shift 1;;
--name) LXC_NAME=$2; shift 2;; --name) LXC_NAME=$2; shift 2;;
--path) LXC_PATH=$2; shift 2;; --path) LXC_PATH=$2; shift 2;;
--rootfs) LXC_ROOTFS=$2; shift 2;; --rootfs) LXC_ROOTFS=$2; shift 2;;
...@@ -195,33 +198,43 @@ if [ -n "$OCI_PASSWORD" ] && [ -z "$OCI_USERNAME" ]; then ...@@ -195,33 +198,43 @@ if [ -n "$OCI_PASSWORD" ] && [ -z "$OCI_USERNAME" ]; then
exit 1 exit 1
fi fi
if [ "${OCI_USE_CACHE}" = "true" ]; then
if ! skopeo copy --help | grep -q 'dest-shared-blob-dir'; then
echo "INFO: skopeo doesn't support blob caching"
OCI_USE_CACHE="false"
fi
fi
USERNS=$(in_userns) USERNS=$(in_userns)
if [ "$USERNS" != "no" ]; then if [ "$USERNS" = "yes" ]; then
if [ -z "$LXC_MAPPED_UID" ] || [ "$LXC_MAPPED_UID" = "-1" ]; then
echo "ERROR: In a user namespace without a map." 1>&2
exit 1
fi
fi
if [ "${OCI_USE_CACHE}" = "true" ]; then
if [ "$USERNS" = "yes" ]; then if [ "$USERNS" = "yes" ]; then
if [ -z "$LXC_MAPPED_UID" ] || [ "$LXC_MAPPED_UID" = "-1" ]; then DOWNLOAD_BASE="${HOME}/.cache/lxc"
echo "ERROR: In a user namespace without a map." 1>&2
exit 1
fi
DOWNLOAD_MODE="user"
DOWNLOAD_TARGET="user"
else else
DOWNLOAD_MODE="user" DOWNLOAD_BASE="${LOCALSTATEDIR}/cache/lxc"
DOWNLOAD_TARGET="system"
fi fi
else
DOWNLOAD_BASE=/tmp
fi fi
# Trap all exit signals # Trap all exit signals
trap cleanup EXIT HUP INT TERM trap cleanup EXIT HUP INT TERM
if ! type mktemp >/dev/null 2>&1; then if ! type mktemp >/dev/null 2>&1; then
DOWNLOAD_TEMP=/tmp/lxc-oci.$$ DOWNLOAD_TEMP="${DOWNLOAD_BASE}/lxc-oci.$$"
mkdir -p $DOWNLOAD_TEMP mkdir -p $DOWNLOAD_TEMP
else else
DOWNLOAD_TEMP=$(mktemp -d) DOWNLOAD_TEMP=$(mktemp -d -p "${DOWNLOAD_BASE}")
fi fi
# Download the image - TODO - cache # Download the image
skopeo_args=("") skopeo_args=("")
if [ -n "$OCI_USERNAME" ]; then if [ -n "$OCI_USERNAME" ]; then
CREDENTIALS="${OCI_USERNAME}" CREDENTIALS="${OCI_USERNAME}"
...@@ -230,7 +243,13 @@ if [ -n "$OCI_USERNAME" ]; then ...@@ -230,7 +243,13 @@ if [ -n "$OCI_USERNAME" ]; then
fi fi
skopeo_args+=(--src-creds "${CREDENTIALS}") skopeo_args+=(--src-creds "${CREDENTIALS}")
fi fi
skopeo copy ${skopeo_args[@]} "${OCI_URL}" "oci:${DOWNLOAD_TEMP}:latest" if [ "${OCI_USE_CACHE}" = "true" ]; then
skopeo_args+=(--dest-shared-blob-dir "${DOWNLOAD_BASE}")
skopeo copy ${skopeo_args[@]} "${OCI_URL}" "oci:${DOWNLOAD_TEMP}:latest"
ln -s "${DOWNLOAD_BASE}/sha256" "${DOWNLOAD_TEMP}/blobs/sha256"
else
skopeo copy ${skopeo_args[@]} "${OCI_URL}" "oci:${DOWNLOAD_TEMP}:latest"
fi
echo "Unpacking the rootfs" echo "Unpacking the rootfs"
umoci_args=("") umoci_args=("")
......
Markdown is supported
0% or
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment